/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package model;

import java.awt.*;

/**
 *
 * @author user
 */
public class MCanvas extends Canvas {

    public State state;
    
    public MCanvas (State s) {
        super();
        state = s;
    }
   
    public void paint(Graphics g) {
        java.awt.Rectangle r = g.getClipBounds();
        g.setColor(Color.WHITE);
        g.fillRect(r.x, r.y, r.width - 1, r.height - 1);

            // Draw cars
        double diffY = (r.height + 0.0) / state.m;
        double diffX = (r.width + 0.0) / state.n;
        for (int x = 1; x <= state.n; x++)
            for (int y = 1; y <= state.m; y++)
                if (state.s[y][x] > 0) {
                    g.setColor((state.s[y][x] == 1) ? Color.RED : Color.BLUE);
                    g.fillRect(
                            (int)Math.round(r.x + (x - 1) * diffX + 1),
                            (int)Math.round(r.y + (y - 1) * diffY + 1),
                            (int)Math.round(diffX - 1),
                            (int)Math.round(diffY - 1)
                    );
                }
        
                    // Draw cell fields
        g.setColor(Color.BLACK);
        g.drawRect(r.x, r.y, r.width - 1, r.height - 1);
        double startY = r.y;
        for (int y = 1; y < state.m; y++) {
            startY += diffY;
            g.drawLine(0, (int)Math.round(startY), r.width - 1, (int)Math.round(startY));
        }
        double startX = r.x;
        for (int x = 1; x < state.n; x++) {
            startX += diffX;
            g.drawLine((int)Math.round(startX), 0, (int)Math.round(startX), r.height - 1);
        }

    }    
}
