/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package model;

/**
 *
 * @author user
 */
public class Runner {
    
    public Model model;
    public State state;
    
    public Runner(Model m, State s) {
        model = m;
        state = s;
    }
    
    public void step() {
        state.moved = 0;
        state.t++;
        for (Car car : state.cars()) {
            if (car.dtp == 1) {
                state.s[car.y][car.x] = 2;
            } else {
                Rule rule = model.getMove(state.getArg(car));
                
                switch(rule.crash) {
                    case 0:
                        break;
                    case 1:
                        state.findCar(car.y - 1, car.x + 1).dtp = 1;
                        break;
                    case 2:
                        state.findCar(car.y, car.x + 1).dtp = 1;
                        break;
                    case 3:
                        state.findCar(car.y + 1, car.x + 1).dtp = 1;                        
                        break;                             
                }

                state.s[car.y][car.x] = 0;
                switch(rule.cell) {
                    case 0:
                        break;
                    case 1:
                        car.x++;
                        car.y--;
                        state.moved++;
                        break;
                    case 2:
                        car.x++;
                        state.moved++;
                        break;
                    case 3:
                        car.x++;
                        car.y++;
                        state.moved++;
                        break;
                }
                if (car.x <= state.n)
                    state.s[car.y][car.x] = rule.s;
            }
        }
        
            // new cars in left column
        for (int y = 1; y <= model.m; y++) {
            double p = Math.random();
            if ((state.s[y][1] == 0) && (p < model.pn)) {
                state.s[y][1] = 1;
                state.moved++;
            }
        }
    }
    
    
}
